// DXFWriterDlg.cpp : implementation file
//
#include <stdafx.h>
#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include "stdafx.h"
#include "DXFWriter.h"
#include "DXFWriterDlg.h"
#include ".\dxfwriterdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

typedef GLfloat Color[3];
static Color red = {0.77, 0.09, 0.0};
static Color green = {0.0, 0.66, 0.27};
static Color blue = {0.0, 0.3, 0.66};
static Color white = {1.0, 1.0, 1.0};
static Color orange = {1.0, 0.38, 0.0};
static Color yellow = {1.0, 1.0, 0.0};
static Color black = {0.1, 0.1, 0.1};
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDXFWriterDlg dialog



CDXFWriterDlg::CDXFWriterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDXFWriterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDXFWriterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDXFWriterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_LINE, OnBnClickedLine)
	ON_BN_CLICKED(IDC_CIRCLE, OnBnClickedCircle)
	ON_BN_CLICKED(IDC_RECTANGLE, OnBnClickedRectangle)
	ON_BN_CLICKED(IDC_LINELOOP, OnBnClickedLineloop)
	ON_BN_CLICKED(IDC_LINE_STRIP, OnBnClickedLineStrip)
	ON_BN_CLICKED(IDC_COLOR_RED, OnBnClickedColorRed)
	ON_BN_CLICKED(IDC_COLOR_GREEN, OnBnClickedColorGreen)
	ON_BN_CLICKED(IDC_COLOR_BLUE, OnBnClickedColorBlue)
	ON_BN_CLICKED(IDC_COLOR_ORANGE, OnBnClickedColorOrange)
	ON_BN_CLICKED(IDC_COLOR_WHITE, OnBnClickedColorWhite)
	ON_BN_CLICKED(IDC_IDC_COLOR_yellow, OnBnClickedIdcColoryellow)
	ON_BN_CLICKED(IDC_SAVE, OnBnClickedSave)
END_MESSAGE_MAP()


// CDXFWriterDlg message handlers

BOOL CDXFWriterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	/***************/
	/* ADDED CODE: */
	/***************/
	CRect rect;

	// Get size and position of the template textfield we created before in the dialog editor
	GetDlgItem(IDC_OPENGL)->GetWindowRect(rect);

	// Convert screen coordinates to client coordinates
	ScreenToClient(rect);

	// Create OpenGL Control window
	m_oglWindow.oglCreate(rect, this);

	// Setup the OpenGL Window's timer to render
	m_oglWindow.m_unpTimer = m_oglWindow.SetTimer(1, 1, 0);

	m_oglWindow.SetCurrentColor(white);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDXFWriterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDXFWriterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDXFWriterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CDXFWriterDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
}
void CDXFWriterDlg::OnBnClickedLine()
{
	m_oglWindow.SetDrawingMode(DM_LINE);
}

void CDXFWriterDlg::OnBnClickedCircle()
{
	m_oglWindow.SetDrawingMode(DM_CIRCLE);
}

void CDXFWriterDlg::OnBnClickedRectangle()
{
	m_oglWindow.SetDrawingMode(DM_RECT);
}

void CDXFWriterDlg::OnBnClickedLineloop()
{
	m_oglWindow.SetDrawingMode(DM_LINELOOP);
}

void CDXFWriterDlg::OnBnClickedLineStrip()
{
	m_oglWindow.SetDrawingMode(DM_LINESTRIP);
}

void CDXFWriterDlg::OnBnClickedColorRed()
{
	m_oglWindow.SetCurrentColor(red);
}

void CDXFWriterDlg::OnBnClickedColorGreen()
{
	m_oglWindow.SetCurrentColor(green);
}

void CDXFWriterDlg::OnBnClickedColorBlue()
{
	m_oglWindow.SetCurrentColor(blue);
}

void CDXFWriterDlg::OnBnClickedColorOrange()
{
	m_oglWindow.SetCurrentColor(orange);
}

void CDXFWriterDlg::OnBnClickedColorWhite()
{
	m_oglWindow.SetCurrentColor(white);
}

void CDXFWriterDlg::OnBnClickedIdcColoryellow()
{
	m_oglWindow.SetCurrentColor(yellow);
}
int CDXFWriterDlg::OpenGLToAutoCADColor(float * color)
{
	if (color == red) return 1;
	if (color == green) return 90;
	if (color == white) return 7;
	if (color == yellow) return 50;
	if (color == orange) return 40;
	if (color == blue) return 170;
	return 7;
}
int CDXFWriterDlg::GetLayerFromColor(float * color)
{
	if (color == green) return 1;
	if (color == white) return 2;
	if (color == yellow) return 3;
	if (color == orange) return 4;
	if (color == blue) return 5;
	if (color == red) return 6;
	return 0;
}
///////////////////////////////////////////////////////////////////////////////////
void CDXFWriterDlg::OnBnClickedSave()
{

	CFileDialog fDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT,"DXF Files (*.dxf)|*.dxf||");

    if(fDlg.DoModal() == IDOK) 
	{
		FILE * file = fopen(fDlg.GetPathName(),"w");
		//Header
		fprintf(file,"0\nSECTION\n2\nHEADER\n9\n$ACADVER\n1\nAC1006\n9\n$EXTMIN\n10\n100\n20\n20\n9\n$EXTMAX\n10\n100\n20\n20\n9\n$LIMMIN\n10\n100\n20\n20\n9\n$LIMMAX\n10\n100\n20\n20\n9\n$TEXTSIZE\n40\n0.2\n0\nENDSEC\n");
		//Tables
		fprintf(file,"");
		//Blocks
		fprintf(file,"0\nSECTION\n2\nBLOCKS\n0\nENDSEC\n");
		//Entitys
		fprintf(file,"0\nSECTION\n2\nENTITIES\n");
		//Lines
		for(int i = 0; i < m_oglWindow.m_iLineCount; i++)
		{
			double x1 = m_oglWindow.m_Lines[i].m_pLeft.x * ZOOM;
			double y1 = m_oglWindow.m_Lines[i].m_pLeft.y * ZOOM;
			double x2 = m_oglWindow.m_Lines[i].m_pRight.x * ZOOM;
			double y2 = m_oglWindow.m_Lines[i].m_pRight.y * ZOOM;
			int layer = GetLayerFromColor(m_oglWindow.m_Lines[i].m_Color);
			int color = OpenGLToAutoCADColor(m_oglWindow.m_Lines[i].m_Color);
			fprintf(file,"0\nLINE\n8\n%d\n62\n%d\n6\nCONTINUOUS\n10\n%f\n20\n%f\n11\n%f\n21\n%f\n",layer,color,x1,y1,x2,y2);
		}
		//Draw poligons
		for(int i = 0; i < m_oglWindow.m_iPoliLineCount; i++)
		{
			int layer = GetLayerFromColor(m_oglWindow.m_PoliLines[i].m_Color);
			int color = OpenGLToAutoCADColor(m_oglWindow.m_PoliLines[i].m_Color);
			fprintf(file,"0\nPOLYLINE\n8\n%d\n62\n%d\n6\nCONTINUOUS\n66\n1\n70\n1\n",layer,color);
			for(int j = 0; j < m_oglWindow.m_PoliLines[i].m_pCount; j++)
			{
				double x = m_oglWindow.m_PoliLines[i].m_pArray[j].x * ZOOM;
				double y = m_oglWindow.m_PoliLines[i].m_pArray[j].y * ZOOM;
				fprintf(file,"0\nVERTEX\n8\n%d\n10\n%f\n20\n%f\n",layer,x,y);

			}
			fprintf(file,"0\nSEQEND\n8\n0\n");
		}
		//Draw circles
		for(int i = 0; i < m_oglWindow.m_iCircleCount; i++)
		{
			double x = m_oglWindow.m_Circles[i].m_pCenter.x * ZOOM;
			double y = m_oglWindow.m_Circles[i].m_pCenter.y * ZOOM;
			double r = m_oglWindow.m_Circles[i].r * ZOOM;
			int layer = GetLayerFromColor( m_oglWindow.m_Circles[i].m_Color);
			int color = OpenGLToAutoCADColor( m_oglWindow.m_Circles[i].m_Color);
			fprintf(file,"0\nCIRCLE\n8\n%d\n62\n%d\n6\nCONTINUOUS\n10\n%f\n20\n%f\n40\n%f\n",layer,color,x,y,r);
		}
		fprintf(file,"0\nENDSEC\n0\nEOF");
		fflush(file);
		fclose(file);
	}
}