#pragma once
#include "afxwin.h"
#include "openglpoint.h"
#include "openglpoliline.h"
#include "openglline.h"
#include "openglrect.h"
#include "openglcircle.h"
#include ".\openglcolor.h"
#include <gl/gl.h>
#include <gl/glu.h>
#include <math.h>

#define DM_EMPTY		0
#define DM_LINELOOP		1
#define DM_CIRCLE		2	
#define DM_RECT			3
#define DM_LINE			4
#define DM_LINESTRIP	5

#define MAX_LINE_COUNT		50
#define MAX_POLILINE_COUNT	50
#define MAX_CIRCLE_COUNT	50
#define MAX_RECT_COUNT		50
#define MAX_POLILINE_LONG	50

class COpenGLControl : public CWnd
{
public:
	/******************/
	/* Public Members */
	/******************/
	UINT_PTR m_unpTimer;
	// View information variables
	float	 m_fLastX;
	float	 m_fLastY;
	float	 m_fPosX;
	float	 m_fPosY;
	float	 m_fZoom;
	float	 m_fRotX;
	float	 m_fRotY;
	bool	 m_bIsMaximized;

	bool		 m_bInProgress;
	int			 m_iDrawingMode;
	COpenGLPoint		 m_pStartPoint;
	COpenGLPoint		 m_pCurrentPoint;

	COpenGLPoint*		 m_tmpPoliLinePoints;
	int					 m_tmpPointCount;

	COpenGLLine*		 m_Lines;
	COpenGLPoliLine*	 m_PoliLines;
	COpenGLRect*		 m_Rects;
	COpenGLCircle*		 m_Circles;

	int			 m_iLineCount;
	int			 m_iPoliLineCount;
	int			 m_iRectCount;
	int			 m_iCircleCount;

	float *		 m_CurrentColor;

private:
	/*******************/
	/* Private Members */
	/*******************/
	// Window information
	CWnd  *hWnd;
	HDC   hdc;			
	HGLRC hrc;			
	int   m_nPixelFormat;
	CRect m_rect;
	CRect m_oldWindow;
	CRect m_originalRect;

private:
	COpenGLPoint ClientToOpenGL(CPoint point);


public:
	COpenGLControl(void);
	virtual ~COpenGLControl(void);

	void oglCreate(CRect rect, CWnd *parent);
	void oglInitialize(void);
	void oglDrawScene(void);

	void SetCurrentColor(float * color);
	void SetDrawingMode(int dMode);

	// Added message classes:
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);

	DECLARE_MESSAGE_MAP()
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
};